# SwaggerClient-php
<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 4.0.0
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen
For more information, please visit [https://www.fax-api.de/support/](https://www.fax-api.de/support/)

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJob($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJob: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJobNotifications($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobNotifications: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJobPreviews($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobPreviews: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job
$object_limit = 100; // int | Query parameter to change de default limitation of objects in the result data array
$object_offset = 0; // int | Query parameter to change de default offset of objects in the result data array
$filter_fax_number = "filter_fax_number_example"; // string | Query parameter to fetch recipients after his fax number
$filter_fax_number_norm = "filter_fax_number_norm_example"; // string | Query parameter to fetch recipients after his normed fax number
$filter_recipient_reference = "filter_recipient_reference_example"; // string | Query parameter to fetch recipients after his recipient reference
$filter_international_dialing_code = "filter_international_dialing_code_example"; // string | Query parameter to fetch recipients after his international dialing code
$filter_result_code = "filter_result_code_example"; // string | Query parameter to fetch recipients after his result code
$filter_result_text = "filter_result_text_example"; // string | Query parameter to fetch recipients after his result text
$sort_field = "sort_field_example"; // string | Available sort options for the result data array.
$sort_order = "asc"; // string | Describes the order for used sort fields

try {
    $result = $apiInstance->getJobRecipients($id, $object_limit, $object_offset, $filter_fax_number, $filter_fax_number_norm, $filter_recipient_reference, $filter_international_dialing_code, $filter_result_code, $filter_result_text, $sort_field, $sort_order);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobRecipients: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJobTemplates($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobTemplates: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\JobsIdBody(); // \Swagger\Client\Model\JobsIdBody | Describes the required request body to perform an action on the fax job
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->putJob($body, $id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->putJob: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*JobDetailsApi* | [**getJob**](docs/Api/JobDetailsApi.md#getjob) | **GET** /jobs/{id} | /jobs/{id}
*JobDetailsApi* | [**getJobNotifications**](docs/Api/JobDetailsApi.md#getjobnotifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
*JobDetailsApi* | [**getJobPreviews**](docs/Api/JobDetailsApi.md#getjobpreviews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
*JobDetailsApi* | [**getJobRecipients**](docs/Api/JobDetailsApi.md#getjobrecipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
*JobDetailsApi* | [**getJobTemplates**](docs/Api/JobDetailsApi.md#getjobtemplates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
*JobDetailsApi* | [**putJob**](docs/Api/JobDetailsApi.md#putjob) | **PUT** /jobs/{id} | /jobs/{id}
*JobsApi* | [**getJobs**](docs/Api/JobsApi.md#getjobs) | **GET** /jobs | /jobs
*JobsApi* | [**postJob**](docs/Api/JobsApi.md#postjob) | **POST** /jobs | /jobs
*RecipientsApi* | [**getRecipients**](docs/Api/RecipientsApi.md#getrecipients) | **GET** /recipients | /recipients
*SystemApi* | [**getHealth**](docs/Api/SystemApi.md#gethealth) | **GET** /health | /health

## Documentation For Models

 - [ErrorAuthenticationResponse](docs/Model/ErrorAuthenticationResponse.md)
 - [ErrorBadRequestResponse](docs/Model/ErrorBadRequestResponse.md)
 - [ErrorInternalServerResponse](docs/Model/ErrorInternalServerResponse.md)
 - [ErrorNotFoundResponse](docs/Model/ErrorNotFoundResponse.md)
 - [ErrorServiceNotAvailableResponse](docs/Model/ErrorServiceNotAvailableResponse.md)
 - [ErrorToManyRequestsResponse](docs/Model/ErrorToManyRequestsResponse.md)
 - [Health](docs/Model/Health.md)
 - [InlineResponse201](docs/Model/InlineResponse201.md)
 - [Job](docs/Model/Job.md)
 - [JobInfo](docs/Model/JobInfo.md)
 - [JobOptions](docs/Model/JobOptions.md)
 - [JobPost](docs/Model/JobPost.md)
 - [JobPostOptions](docs/Model/JobPostOptions.md)
 - [JobPostRecipient](docs/Model/JobPostRecipient.md)
 - [JobRecipient](docs/Model/JobRecipient.md)
 - [JobRecipients](docs/Model/JobRecipients.md)
 - [JobStatistics](docs/Model/JobStatistics.md)
 - [Jobs](docs/Model/Jobs.md)
 - [JobsIdBody](docs/Model/JobsIdBody.md)
 - [Notification](docs/Model/Notification.md)
 - [Notifications](docs/Model/Notifications.md)
 - [Preview](docs/Model/Preview.md)
 - [Recipient](docs/Model/Recipient.md)
 - [RecipientJob](docs/Model/RecipientJob.md)
 - [Recipients](docs/Model/Recipients.md)
 - [Template](docs/Model/Template.md)
 - [Templates](docs/Model/Templates.md)

## Documentation For Authorization


## ApiAuthKey

- **Type**: API key
- **API key parameter name**: X-Auth-Token
- **Location**: HTTP header


## Author

support@fax-api.de

