<?php
/**
 * Recipient
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Faxsuite RESTful API
 *
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.35
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * Recipient Class Doc Comment
 *
 * @category Class
 * @description Model of containing recipient information
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class Recipient implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'Recipient';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'job' => '\Swagger\Client\Model\RecipientJob',
'fax_number' => 'string',
'fax_number_norm' => 'string',
'international_dialing_code' => 'string',
'name' => 'string',
'recipient_reference' => 'string',
'fare_zone' => 'int',
'sender_time' => '\DateTime',
'result_code' => 'int',
'result_text' => 'string'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'job' => null,
'fax_number' => null,
'fax_number_norm' => null,
'international_dialing_code' => null,
'name' => null,
'recipient_reference' => null,
'fare_zone' => null,
'sender_time' => 'date-time',
'result_code' => null,
'result_text' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'job' => 'job',
'fax_number' => 'faxNumber',
'fax_number_norm' => 'faxNumberNorm',
'international_dialing_code' => 'internationalDialingCode',
'name' => 'name',
'recipient_reference' => 'recipientReference',
'fare_zone' => 'fareZone',
'sender_time' => 'senderTime',
'result_code' => 'resultCode',
'result_text' => 'resultText'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'job' => 'setJob',
'fax_number' => 'setFaxNumber',
'fax_number_norm' => 'setFaxNumberNorm',
'international_dialing_code' => 'setInternationalDialingCode',
'name' => 'setName',
'recipient_reference' => 'setRecipientReference',
'fare_zone' => 'setFareZone',
'sender_time' => 'setSenderTime',
'result_code' => 'setResultCode',
'result_text' => 'setResultText'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'job' => 'getJob',
'fax_number' => 'getFaxNumber',
'fax_number_norm' => 'getFaxNumberNorm',
'international_dialing_code' => 'getInternationalDialingCode',
'name' => 'getName',
'recipient_reference' => 'getRecipientReference',
'fare_zone' => 'getFareZone',
'sender_time' => 'getSenderTime',
'result_code' => 'getResultCode',
'result_text' => 'getResultText'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['job'] = isset($data['job']) ? $data['job'] : null;
        $this->container['fax_number'] = isset($data['fax_number']) ? $data['fax_number'] : null;
        $this->container['fax_number_norm'] = isset($data['fax_number_norm']) ? $data['fax_number_norm'] : null;
        $this->container['international_dialing_code'] = isset($data['international_dialing_code']) ? $data['international_dialing_code'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['recipient_reference'] = isset($data['recipient_reference']) ? $data['recipient_reference'] : null;
        $this->container['fare_zone'] = isset($data['fare_zone']) ? $data['fare_zone'] : null;
        $this->container['sender_time'] = isset($data['sender_time']) ? $data['sender_time'] : null;
        $this->container['result_code'] = isset($data['result_code']) ? $data['result_code'] : null;
        $this->container['result_text'] = isset($data['result_text']) ? $data['result_text'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets job
     *
     * @return \Swagger\Client\Model\RecipientJob
     */
    public function getJob()
    {
        return $this->container['job'];
    }

    /**
     * Sets job
     *
     * @param \Swagger\Client\Model\RecipientJob $job job
     *
     * @return $this
     */
    public function setJob($job)
    {
        $this->container['job'] = $job;

        return $this;
    }

    /**
     * Gets fax_number
     *
     * @return string
     */
    public function getFaxNumber()
    {
        return $this->container['fax_number'];
    }

    /**
     * Sets fax_number
     *
     * @param string $fax_number Recipient fax number
     *
     * @return $this
     */
    public function setFaxNumber($fax_number)
    {
        $this->container['fax_number'] = $fax_number;

        return $this;
    }

    /**
     * Gets fax_number_norm
     *
     * @return string
     */
    public function getFaxNumberNorm()
    {
        return $this->container['fax_number_norm'];
    }

    /**
     * Sets fax_number_norm
     *
     * @param string $fax_number_norm Normed recipient fax number
     *
     * @return $this
     */
    public function setFaxNumberNorm($fax_number_norm)
    {
        $this->container['fax_number_norm'] = $fax_number_norm;

        return $this;
    }

    /**
     * Gets international_dialing_code
     *
     * @return string
     */
    public function getInternationalDialingCode()
    {
        return $this->container['international_dialing_code'];
    }

    /**
     * Sets international_dialing_code
     *
     * @param string $international_dialing_code The International Dialing Code used for this fax
     *
     * @return $this
     */
    public function setInternationalDialingCode($international_dialing_code)
    {
        $this->container['international_dialing_code'] = $international_dialing_code;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Recipient name
     *
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets recipient_reference
     *
     * @return string
     */
    public function getRecipientReference()
    {
        return $this->container['recipient_reference'];
    }

    /**
     * Sets recipient_reference
     *
     * @param string $recipient_reference Recipient reference
     *
     * @return $this
     */
    public function setRecipientReference($recipient_reference)
    {
        $this->container['recipient_reference'] = $recipient_reference;

        return $this;
    }

    /**
     * Gets fare_zone
     *
     * @return int
     */
    public function getFareZone()
    {
        return $this->container['fare_zone'];
    }

    /**
     * Sets fare_zone
     *
     * @param int $fare_zone Used fare zone for the fax
     *
     * @return $this
     */
    public function setFareZone($fare_zone)
    {
        $this->container['fare_zone'] = $fare_zone;

        return $this;
    }

    /**
     * Gets sender_time
     *
     * @return \DateTime
     */
    public function getSenderTime()
    {
        return $this->container['sender_time'];
    }

    /**
     * Sets sender_time
     *
     * @param \DateTime $sender_time Time fax was send to recipient. The format complies with ISO 8601 and contains date and time
     *
     * @return $this
     */
    public function setSenderTime($sender_time)
    {
        $this->container['sender_time'] = $sender_time;

        return $this;
    }

    /**
     * Gets result_code
     *
     * @return int
     */
    public function getResultCode()
    {
        return $this->container['result_code'];
    }

    /**
     * Sets result_code
     *
     * @param int $result_code Contains the result code for the fax. Value is only present if a result of the fax transmission is available, otherwise it is 'null'. Please see here for further information: <a href=\"https://hilfe.faxverteiler.com/ergebnis-code/\"><b>https://hilfe.faxverteiler.com/ergebnis-code/</b></a>
     *
     * @return $this
     */
    public function setResultCode($result_code)
    {
        $this->container['result_code'] = $result_code;

        return $this;
    }

    /**
     * Gets result_text
     *
     * @return string
     */
    public function getResultText()
    {
        return $this->container['result_text'];
    }

    /**
     * Sets result_text
     *
     * @param string $result_text Contains the result text for the fax. Value is only present if a result of the fax transmission is available, otherwise it is 'null'. Please see here for further information: <a href=\"https://hilfe.faxverteiler.com/ergebnis-code/\"><b>https://hilfe.faxverteiler.com/ergebnis-code/</b></a>
     *
     * @return $this
     */
    public function setResultText($result_text)
    {
        $this->container['result_text'] = $result_text;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
